<script setup lang="ts">
  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
  }>();

  const {
    needSetup,
    onDeviceChange,
    stream,
    streamLoading,
    applySelectedDevices,
    microphoneDeviceId,
    cameraDeviceId,
    speakerDeviceId,
    setJoinedWithAudioOnly,
  } = useVideoSetup();
  const { microphoneDevices, speakerDevices, cameraDevices } = useMediaDevices();
  const { setup: setupVideoCall } = useVideoCall();

  const selectedDevices = reactive<{
    microphoneDevice: MediaDeviceInfo | null;
    speakerDevice: MediaDeviceInfo | null;
    cameraDevice: MediaDeviceInfo | null;
  }>({
    microphoneDevice: null,
    speakerDevice: null,
    cameraDevice: null,
  });

  watch(
    [microphoneDevices, speakerDevices, cameraDevices],
    (v) => {
      const [microphoneDevicesValue, speakerDevicesValue, cameraDevicesValue] = v;
      if (microphoneDevicesValue && speakerDevicesValue && cameraDevicesValue) {
        const defaultMicrophoneDevice = microphoneDeviceId.value
          ? microphoneDevicesValue.find((x) => x.deviceId === microphoneDeviceId.value)
          : microphoneDevicesValue[0];
        const defaultCameraDevice = cameraDeviceId.value
          ? cameraDevicesValue.find((x) => x.deviceId === cameraDeviceId.value)
          : cameraDevicesValue[0];
        const defaultSpeakerDevice = speakerDeviceId.value
          ? speakerDevicesValue.find((x) => x.deviceId === speakerDeviceId.value)
          : speakerDevicesValue[0];
        selectedDevices.microphoneDevice = defaultMicrophoneDevice!;
        selectedDevices.speakerDevice = defaultSpeakerDevice!;
        selectedDevices.cameraDevice = defaultCameraDevice!;
      }
    },
    {
      immediate: true,
      deep: true,
    },
  );

  watch(
    selectedDevices,
    async (devicesValue) => {
      if (devicesValue) {
        await onDeviceChange(
          {
            audio: devicesValue?.microphoneDevice?.deviceId,
            video: devicesValue?.cameraDevice?.deviceId,
          },
          true,
        );
      }
    },
    {
      immediate: true,
      deep: true,
    },
  );

  const onSubmit = () => {
    applySelectedDevices({
      cameraDeviceId: selectedDevices.cameraDevice?.deviceId,
      microphoneDeviceId: selectedDevices.microphoneDevice?.deviceId,
      speakerDeviceId: selectedDevices.speakerDevice?.deviceId,
    });
    setJoinedWithAudioOnly(false);
    props.controller.close();
    setupVideoCall();
  };

  const onReload = () => {
    location.reload();
  };
</script>

<template>
  <SwModal
    backdrop-display="static"
    panel-class="md:!w-2xl"
    :controller="controller"
    :modal-title="$t('setting.videoAudio')"
  >
    <template #body>
      <div class="-m-6 flex flex-col gap-8 p-6">
        <slot name="video">
          <div v-if="cameraDevices" class="flex flex-col gap-6 md:flex-row">
            <div class="min-w-0 flex-1">
              <SwVideoView is-mute :loading="streamLoading" :stream-src="stream">
                <template #icon>
                  <span class="i-sw-solid:microphone-slash text-crimson-500 ml-1.5 text-sm" />
                </template>
              </SwVideoView>
            </div>
            <div class="flex min-w-0 flex-1 flex-col">
              <label class="text-base font-bold">{{ $t('setting.video') }}</label>
              <span class="text-information-subdued pb-3 text-sm">{{
                $t('setting.videoHint')
              }}</span>
              <SwSelect
                v-if="cameraDevices"
                v-model="selectedDevices.cameraDevice"
                key-field="deviceId"
                label-field="label"
                return-object-value
                :options="cameraDevices"
                size="large"
              />
            </div>
          </div>
          <div v-else class="flex flex-col space-y-8">
            <SwEmptyState
              :title="$t('presentation.joinNoDevices.noDevices')"
              :sublime="$t('presentation.joinNoDevices.noDevicesDescription')"
              class="mx-auto max-w-[440px]"
            >
              <template #icon>
                <span class="i-sw-solid:video-slash m-auto p-0" />
              </template>
              <template #actions>
                <SwButton class="mx-auto mb-2 font-medium" @click="onReload"
                  >{{ $t('presentation.joinNoDevices.tryAgain') }}
                </SwButton>
              </template>
            </SwEmptyState>
            <AllowDeviceSteps />
          </div>
        </slot>
        <slot name="audio">
          <div class="border-t pt-6">
            <div class="mb-3 font-semibold">
              {{ $t('setting.audio') }}
            </div>
            <div class="flex flex-col gap-6 md:flex-row">
              <div class="min-w-0 flex-1">
                <SwSelect
                  v-model="selectedDevices.microphoneDevice"
                  key-field="deviceId"
                  label-field="label"
                  return-object-value
                  :label="$t('setting.microphone')"
                  :options="microphoneDevices"
                  :placeholder="$t('presentation.noDevices')"
                  size="large"
                />
              </div>
              <div class="min-w-0 flex-1">
                <SwSelect
                  v-model="selectedDevices.speakerDevice"
                  key-field="deviceId"
                  label-field="label"
                  :label="$t('setting.speaker')"
                  return-object-value
                  :options="speakerDevices"
                  size="large"
                  :placeholder="$t('presentation.noDevices')"
                />
              </div>
            </div>
          </div>
        </slot>
      </div>
    </template>
    <template #footer>
      <SwButton v-if="!needSetup" size="large" variant="action" @click="controller.close()">{{
        $t('cancel')
      }}</SwButton>
      <SwButton size="large" @click="onSubmit">{{ $t('save') }}</SwButton>
    </template>
  </SwModal>
</template>
